1
0
mirror of https://cgit.krebsco.de/krops synced 2024-06-13 11:03:38 +02:00

Compare commits

...

31 Commits

Author SHA1 Message Date
tv
a6c7ecd8ba populate: add passage source type 2024-01-11 11:23:11 +01:00
lassulus
cbc475bdf4 init flake.nix 2023-07-22 23:31:40 +02:00
Lassulus
1c524b6727
Merge pull request #38 from fuu0/patch-1
Update README.md to fix broken link with infos to the `target` attribute
2023-04-08 17:14:42 +02:00
fuu0
9c0d53cf44
Update README.md
fix broken link to with infos to the `target` attribute
2023-04-08 17:00:11 +02:00
lassulus
59aa5d0e41 populate pass: calculate hash for each symlink
this fixes folders with symlinks not getting updated if the symlinked
file is in another subfolder of the pass repo
2023-03-13 10:49:57 +01:00
tv
3ebbfc6261 rebuild: set NIX_PATH like everywhere else 2022-09-07 11:56:51 +02:00
tv
e5c13343a6 withNixOutputMonitor: run shell with know Nix path 2022-09-07 11:55:35 +02:00
tv
6ee1d00b92 runShell: admit non-posix-compatible shells 2022-09-07 11:17:39 +02:00
tv
625bd446dd krops writeDeploy: add useNixOutputMonitor parameter 2022-08-23 14:16:39 +02:00
tv
3aa04be96f Merge remote-tracking branch 'prism/master' 2022-07-26 21:03:55 +02:00
lassulus
117b0b32cd krops writeTest: make trace optional 2022-07-26 21:02:05 +02:00
tv
9c49e9aa24 krops writeDeploy: add operation parameter 2022-07-16 16:50:32 +02:00
tv
89e5e67659 populate git: remove trailing spaces 2022-02-12 10:07:17 +01:00
tv
824aa36b2a populate git: remove non-worktree target 2022-02-12 10:06:34 +01:00
tv
13ae434b14
Merge pull request #35 from erikarvstedt/fix-ssh-port
target: use default port from SSH config
2021-11-20 15:46:09 +01:00
Erik Arvstedt
9fc8cbf8e8 target: use default port from SSH config
This is the expected behavior.
The SSH config is also implicitly used for other SSH-related settings.
2021-11-20 14:28:54 +01:00
tv
05f0d3b5c1 populate file: isDerivation -> isStorePath 2021-10-26 19:36:12 +02:00
tv
6ef8900af4 populate file: admit derivations 2021-10-26 13:52:25 +02:00
tv
53eda9cafe README: transfered -> transferred 2021-10-26 13:52:25 +02:00
tv
bdce88820b README: talk about systems 2021-10-26 13:52:25 +02:00
tv
0fc8f1b2a6 populate: add rsyncDefaultConfig 2021-10-26 13:52:25 +02:00
lassulus
d80cb74c74 runShell/writeCommand: add allocateTTY argument 2021-10-26 13:51:18 +02:00
lassulus
c1b24328c4 krops writeDeploy: deprecate fast parameter 2021-10-26 13:51:07 +02:00
Matthias Beyer
a3bda5c49b README: use latest krops version in example
Signed-off-by: Matthias Beyer <mail@beyermatthias.de>
2021-10-26 13:51:04 +02:00
lassulus
b78e4d5a92 README: update irc link 2021-07-22 08:19:15 +02:00
Lassulus
cccebf3ff7
Merge pull request #30 from krebs/fixups
(hopefully) fix pass with subfolders, make README more clear for extraOptions
2021-03-23 22:47:37 +01:00
lassulus
2ea0cdb99d README: better usecase for extraOptions 2021-02-16 19:29:51 +01:00
lassulus
438d3f8738 populate pass: don't decrypt .gpg-id 2021-02-16 19:29:41 +01:00
lassulus
9eb2c2d0d6 populate pass: make git optional again 2021-01-17 17:18:05 +01:00
tv
c2fa48550f isLocalTarget: use "localhost" as default
This fixes an issue when trying to deploy using sudo from systems that
don't provide means to determine the real host name.
2021-01-16 14:12:45 +01:00
tv
efe400d87c README: ops -> operations
Because there's no need to save on characters.
2021-01-05 22:54:24 +01:00
8 changed files with 341 additions and 80 deletions

View File

@ -1,4 +1,4 @@
# krops (krebs ops) # krops (krebs operations)
krops is a lightweight toolkit to deploy NixOS systems, remotely or locally. krops is a lightweight toolkit to deploy NixOS systems, remotely or locally.
@ -6,7 +6,8 @@ krops is a lightweight toolkit to deploy NixOS systems, remotely or locally.
## Some Features ## Some Features
- store your secrets in [password store](https://www.passwordstore.org/) - store your secrets in [password store](https://www.passwordstore.org/)
- build your system remotely or [passage](https://github.com/FiloSottile/passage)
- build your systems remotely
- minimal overhead (it's basically just `nixos-rebuild switch`!) - minimal overhead (it's basically just `nixos-rebuild switch`!)
- run from custom nixpkgs branch/checkout/fork - run from custom nixpkgs branch/checkout/fork
@ -19,8 +20,8 @@ Create a file named `krops.nix` (name doesn't matter) with following content:
let let
krops = (import <nixpkgs> {}).fetchgit { krops = (import <nixpkgs> {}).fetchgit {
url = https://cgit.krebsco.de/krops/; url = https://cgit.krebsco.de/krops/;
rev = "v1.17.0"; rev = "v1.25.0";
sha256 = "150jlz0hlb3ngf9a1c9xgcwzz1zz8v2lfgnzw08l3ajlaaai8smd"; sha256 = "07mg3iaqjf1w49vmwfchi7b1w55bh7rvsbgicp2m47gnj9alwdb6";
}; };
lib = import "${krops}/lib"; lib = import "${krops}/lib";
@ -89,14 +90,14 @@ pkgs.krops.writeDeploy "deploy" {
source = /* ... */; source = /* ... */;
target = lib.mkTarget "user@host/path" // { target = lib.mkTarget "user@host/path" // {
extraOptions = [ extraOptions = [
"-oLogLevel=DEBUG" "-o" "LogLevel=DEBUG"
]; ];
sudo = true; sudo = true;
}; };
} }
``` ```
For more details about the `target` attribute, please check the `mkTarget` For more details about the `target` attribute, please check the `mkTarget`
function in [lib/default.nix](lib/defaults.nix). function in [lib/default.nix](lib/default.nix).
### `backup` (optional, defaults to false) ### `backup` (optional, defaults to false)
@ -125,13 +126,40 @@ architecture.
### `fast` (optional, defaults to false) ### `fast` (optional, defaults to false)
Run `nixos-rebuild switch` immediately without building the system Run `nixos-rebuild` immediately without building the system in a dedicated `nix
in a dedicated `nix build` step. build` step.
### `force` (optional, defaults to false) ### `force` (optional, defaults to false)
Create the sentinel file (`/var/src/.populate`) before syncing the new source. Create the sentinel file (`/var/src/.populate`) before syncing the new source.
### `operation` (optional, defaults to "switch")
Specifies which `nixos-rebuild` operation to perform.
### `useNixOutputMonitor` (optional, defaults to `"opportunistic"`)
Specifies when to pipe `nixos-rebuild`'s output to
[nom](https://github.com/maralorn/nix-output-monitor).
Supported values:
* `"opportunistic"` (default) -
Use `nom` only if it is present on the target machine.
* `"optimistic"` -
Use `nom`, assuming it is present on the target machine.
* `"pessimistic"` -
Use `nom` via `nix-shell` on the target machine.
* `true` -
Use `nom`.
If it is not present on the target machine, then use it via `nix-shell`.
* `false` -
Don't use `nom`
## writeTest ## writeTest
Very similiar to writeDeploy, but just builds the system on the target without Very similiar to writeDeploy, but just builds the system on the target without
@ -152,6 +180,10 @@ below `/var/src`, and executes `NIX_PATH=/var/src nix-build -A system '<nixpkgs/
[see `writeDeploy`](#writeDeploy) [see `writeDeploy`](#writeDeploy)
### `trace` (optional, defaults to false)
run nix-build with `--show-trace`
## writeCommand ## writeCommand
This can be used to run other commands than `nixos-rebuild` or pre/post build hooks. This can be used to run other commands than `nixos-rebuild` or pre/post build hooks.
@ -185,6 +217,10 @@ pkgs.krops.writeCommand "deploy-with-swap" {
[see `writeDeploy`](#writeDeploy) [see `writeDeploy`](#writeDeploy)
### `allocateTTY` (optional, defaults to false)
whether the ssh session should do a pseudo-terminal allocation.
sets `-t` on the ssh command.
## Source Types ## Source Types
@ -206,13 +242,15 @@ using [`rsync`](https://rsync.samba.org/).
Supported attributes: Supported attributes:
* `path` - * `path` -
absolute path to files that should by transfered absolute path to files that should by transferred.
* `useChecksum` (optional) - * `useChecksum` (optional) -
boolean that controls whether file contents should be checked to decide boolean that controls whether file contents should be checked to decide
whether a file has changed. This is useful when `path` points at files whether a file has changed. This is useful when `path` points at files
with mangled timestamps, e.g. the Nix store. with mangled timestamps, e.g. the Nix store.
The default value is `true` if `path` is a derivation, and `false` otherwise.
* `filters` (optional) * `filters` (optional)
List of filters that should be passed to [`rsync`](https://rsync.samba.org/). List of filters that should be passed to [`rsync`](https://rsync.samba.org/).
Filters are specified as attribute sets with the attributes `type` and Filters are specified as attribute sets with the attributes `type` and
@ -261,6 +299,29 @@ Supported attributes:
sub-directory in the password store. sub-directory in the password store.
### `passage`
The passage source type decrypts files from a local
[passage store](https://github.com/FiloSottile/passage)
and transfers them to the target using
[`rsync`](https://rsync.samba.org/).
Supported attributes:
* `dir` -
Path to the passage store.
For a partial transfer, this may point to a subdirectory.
Example: `~/.passage/store/hosts/MYHOSTNAME`
* `identities_file` (optional) -
Path to the identities file.
Defaults to `~/.passage/identities`.
* `age` (optional) -
Path of the age binary.
Defaults to `age` (absolute path gets resolved using `passage`'s search path.)
### `pipe` ### `pipe`
Executes a local command, capture its stdout, and send that as a file to the Executes a local command, capture its stdout, and send that as a file to the
@ -292,6 +353,6 @@ Supported attributes:
Comments, questions, pull-requests and patches, etc. are very welcome, and can be directed Comments, questions, pull-requests and patches, etc. are very welcome, and can be directed
at: at:
- IRC: #krebs at freenode - IRC: #krebs at hackint
- Mail: [spam@krebsco.de](mailto:spam@krebsco.de) - Mail: [spam@krebsco.de](mailto:spam@krebsco.de)
- Github: https://github.com/krebs/krops/ - Github: https://github.com/krebs/krops/

4
ci.nix
View File

@ -5,7 +5,7 @@ let
pkgs = import "${krops}/pkgs" {}; pkgs = import "${krops}/pkgs" {};
source = lib.evalSource [{ source = lib.evalSource [{
nixos-config.file = toString (pkgs.writeText "nixos-config" '' nixos-config.file = pkgs.writeText "nixos-config" ''
{ pkgs, ... }: { { pkgs, ... }: {
fileSystems."/" = { device = "/dev/sda1"; }; fileSystems."/" = { device = "/dev/sda1"; };
@ -13,7 +13,7 @@ let
services.openssh.enable = true; services.openssh.enable = true;
environment.systemPackages = [ pkgs.git ]; environment.systemPackages = [ pkgs.git ];
} }
''); '';
nixpkgs.symlink = toString <nixpkgs>; nixpkgs.symlink = toString <nixpkgs>;
}]; }];
in { in {

27
flake.lock Normal file
View File

@ -0,0 +1,27 @@
{
"nodes": {
"nixpkgs": {
"locked": {
"lastModified": 1689940971,
"narHash": "sha256-397xShPnFqPC59Bmpo3lS+/Aw0yoDRMACGo1+h2VJMo=",
"owner": "NixOS",
"repo": "nixpkgs",
"rev": "9ca785644d067445a4aa749902b29ccef61f7476",
"type": "github"
},
"original": {
"owner": "NixOS",
"ref": "nixos-unstable",
"repo": "nixpkgs",
"type": "github"
}
},
"root": {
"inputs": {
"nixpkgs": "nixpkgs"
}
}
},
"root": "root",
"version": 7
}

29
flake.nix Normal file
View File

@ -0,0 +1,29 @@
{
description = "krops - krebs operations";
inputs = {
nixpkgs.url = "github:NixOS/nixpkgs/nixos-unstable";
};
outputs = { self, nixpkgs, ... }:
let
supportedSystems = [
"x86_64-linux"
"i686-linux"
"aarch64-linux"
"riscv64-linux"
];
forAllSystems = nixpkgs.lib.genAttrs supportedSystems;
in
{
lib = forAllSystems (system:
let
pkgs = nixpkgs.legacyPackages.${system};
krops = pkgs.callPackage ./pkgs/krops {};
populate = pkgs.callPackage ./pkgs/populate {};
in {
inherit populate;
inherit (krops) rebuild runShell withNixOutputMonitor writeCommand writeDeploy writeTest;
});
};
}

View File

@ -28,13 +28,20 @@ let {
# This function's return value can be used as pkgs.populate input. # This function's return value can be used as pkgs.populate input.
source: sanitize (eval source).config.source; source: sanitize (eval source).config.source;
getHostName = let maybeHostName = default: let
# We're parsing /etc/hostname here because reading # We're parsing /etc/hostname here because reading
# /proc/sys/kernel/hostname yields "" # /proc/sys/kernel/hostname yields ""
y = lib.filter lib.types.label.check (lib.splitString "\n" (lib.readFile /etc/hostname)); path = "/etc/hostname";
lines = lib.splitString "\n" (lib.readFile path);
hostNames = lib.filter lib.types.label.check lines;
in in
if lib.length y != 1 then throw "malformed /etc/hostname" else if lib.pathExists path then
lib.elemAt y 0; if lib.length hostNames == 1 then
lib.head hostNames
else
lib.trace "malformed ${path}" default
else
default;
firstWord = s: firstWord = s:
lib.head (lib.match "^([^[:space:]]*).*" s); lib.head (lib.match "^([^[:space:]]*).*" s);
@ -50,9 +57,9 @@ let {
elemAt' = xs: i: if lib.length xs > i then lib.elemAt xs i else null; elemAt' = xs: i: if lib.length xs > i then lib.elemAt xs i else null;
filterNull = lib.filterAttrs (n: v: v != null); filterNull = lib.filterAttrs (n: v: v != null);
in { in {
user = lib.getEnv "LOGNAME"; user = lib.maybeEnv "LOGNAME" null;
host = lib.maybeEnv "HOSTNAME" lib.getHostName; host = lib.maybeEnv "HOSTNAME" (lib.maybeHostName "localhost");
port = "22"; port = null;
path = "/var/src"; path = "/var/src";
sudo = false; sudo = false;
extraOptions = []; extraOptions = [];
@ -63,6 +70,10 @@ let {
path = elemAt' parse 6; path = elemAt' parse 6;
} else s); } else s);
mkUserPortSSHOpts = target:
(lib.optionals (target.user != null) ["-l" target.user]) ++
(lib.optionals (target.port != null) ["-p" target.port]);
shell = let shell = let
isSafeChar = lib.testString "[-+./0-9:=A-Z_a-z]"; isSafeChar = lib.testString "[-+./0-9:=A-Z_a-z]";
quoteChar = c: quoteChar = c:

View File

@ -21,11 +21,15 @@
}; };
file = lib.mkOption { file = lib.mkOption {
apply = x: apply = x:
if lib.types.absolute-pathname.check x if lib.types.absolute-pathname.check x || lib.types.package.check x
then { path = x; } then { path = x; }
else x; else x;
default = null; default = null;
type = lib.types.nullOr (lib.types.either lib.types.absolute-pathname source-types.file); type = lib.types.nullOr (lib.types.oneOf [
lib.types.absolute-pathname
lib.types.package
source-types.file
]);
}; };
git = lib.mkOption { git = lib.mkOption {
default = null; default = null;
@ -35,6 +39,17 @@
default = null; default = null;
type = lib.types.nullOr source-types.pass; type = lib.types.nullOr source-types.pass;
}; };
passage = lib.mkOption {
apply = x:
if lib.types.pathname.check x
then { dir = x; }
else x;
default = null;
type = lib.types.nullOr (lib.types.oneOf [
lib.types.pathname
source-types.passage
]);
};
pipe = lib.mkOption { pipe = lib.mkOption {
apply = x: apply = x:
if lib.types.absolute-pathname.check x if lib.types.absolute-pathname.check x
@ -156,6 +171,21 @@
}; };
}; };
}; };
passage = lib.types.submodule {
options = {
age = lib.mkOption {
default = "age";
type = lib.types.pathname;
};
dir = lib.mkOption {
type = lib.types.pathname;
};
identities_file = lib.mkOption {
default = toString ~/.passage/identities;
type = lib.types.pathname;
};
};
};
pipe = lib.types.submodule { pipe = lib.types.submodule {
options = { options = {
command = lib.mkOption { command = lib.mkOption {

View File

@ -4,40 +4,77 @@ in
{ nix, openssh, populate, writers }: rec { { nix, openssh, populate, writers }: rec {
build = target: rebuild = {
runShell target (lib.concatStringsSep " " [ useNixOutputMonitor
"nix build" }:
"-I ${lib.escapeShellArg target.path}" args: target:
"--no-link -f '<nixpkgs/nixos>'" runShell target {}
"config.system.build.toplevel" (withNixOutputMonitor target useNixOutputMonitor /* sh */ ''
]); NIX_PATH=${lib.escapeShellArg target.path} \
nixos-rebuild ${lib.escapeShellArgs args}
'');
rebuild = args: target: runShell = target: {
runShell target "nixos-rebuild -I ${lib.escapeShellArg target.path} ${ allocateTTY ? false
lib.concatMapStringsSep " " lib.escapeShellArg args }: command:
}";
runShell = target: command:
let let
command' = if target.sudo then "sudo ${command}" else command; command' = /* sh */ ''
${lib.optionalString target.sudo "sudo"} \
/bin/sh -c ${lib.escapeShellArg command}
'';
in in
if lib.isLocalTarget target if lib.isLocalTarget target
then command' then command'
else else
writers.writeDash "krops.${target.host}.${lib.firstWord command}" '' writers.writeDash "krops.${target.host}.${lib.firstWord command}" ''
exec ${openssh}/bin/ssh ${lib.escapeShellArgs (lib.flatten [ exec ${openssh}/bin/ssh ${lib.escapeShellArgs (lib.flatten [
(lib.optionals (target.user != "") ["-l" target.user]) (lib.mkUserPortSSHOpts target)
"-p" target.port (if allocateTTY then "-t" else "-T")
"-T"
target.extraOptions target.extraOptions
target.host target.host
command'])} command'
])}
''; '';
withNixOutputMonitor = target: mode_: command: let
mode =
lib.getAttr (lib.typeOf mode_) {
bool = lib.toJSON mode_;
string = mode_;
};
in /* sh */ ''
printf '# use nix-output-monitor: %s\n' ${lib.escapeShellArg mode} >&2
${lib.getAttr mode rec {
opportunistic = /* sh */ ''
if command -v nom >/dev/null; then
${optimistic}
else
${false}
fi
'';
optimistic = /* sh */ ''
(${command}) 2>&1 | nom
'';
pessimistic = /* sh */ ''
NIX_PATH=${lib.escapeShellArg target.path} \
nix-shell -p nix-output-monitor --run ${lib.escapeShellArg optimistic}
'';
true = /* sh */ ''
if command -v nom >/dev/null; then
${optimistic}
else
${pessimistic}
fi
'';
false = command;
}}
'';
writeCommand = name: { writeCommand = name: {
command ? (targetPath: "echo ${targetPath}"), command ? (targetPath: "echo ${targetPath}"),
backup ? false, backup ? false,
force ? false, force ? false,
allocateTTY ? false,
source, source,
target target
}: let }: let
@ -46,17 +83,19 @@ in
writers.writeDash name '' writers.writeDash name ''
set -efu set -efu
${populate { inherit backup force source; target = target'; }} ${populate { inherit backup force source; target = target'; }}
${runShell target' (command target'.path)} ${runShell target' { inherit allocateTTY; } (command target'.path)}
''; '';
writeDeploy = name: { writeDeploy = name: {
backup ? false, backup ? false,
buildTarget ? null, buildTarget ? null,
crossDeploy ? false, crossDeploy ? false,
fast ? false, fast ? null,
force ? false, force ? false,
operation ? "switch",
source, source,
target target,
useNixOutputMonitor ? "opportunistic"
}: let }: let
buildTarget' = buildTarget' =
if buildTarget == null if buildTarget == null
@ -64,32 +103,31 @@ in
else lib.mkTarget buildTarget; else lib.mkTarget buildTarget;
target' = lib.mkTarget target; target' = lib.mkTarget target;
in in
writers.writeDash name '' lib.traceIf (fast != null) "writeDeploy: it's now always fast, setting the `fast` attribute is deprecated and will be removed in future" (
set -efu writers.writeDash name ''
${lib.optionalString (buildTarget' != target') set -efu
(populate { inherit backup force source; target = buildTarget'; })} ${lib.optionalString (buildTarget' != target')
${populate { inherit backup force source; target = target'; }} (populate { inherit backup force source; target = buildTarget'; })}
${lib.optionalString (! fast) '' ${populate { inherit backup force source; target = target'; }}
${rebuild ["dry-build"] buildTarget'} ${rebuild { inherit useNixOutputMonitor; } ([
${build buildTarget'} operation
''} ] ++ lib.optionals crossDeploy [
${rebuild ([ "--no-build-nix"
"switch" ] ++ lib.optionals (buildTarget' != target') [
] ++ lib.optionals crossDeploy [ "--build-host" "${buildTarget'.user}@${buildTarget'.host}"
"--no-build-nix" "--target-host" "${target'.user}@${target'.host}"
] ++ lib.optionals (buildTarget' != target') [ ] ++ lib.optionals target'.sudo [
"--build-host" "${buildTarget'.user}@${buildTarget'.host}" "--use-remote-sudo"
"--target-host" "${target'.user}@${target'.host}" ]) buildTarget'}
] ++ lib.optionals target'.sudo [ ''
"--use-remote-sudo" );
]) buildTarget'}
'';
writeTest = name: { writeTest = name: {
backup ? false, backup ? false,
force ? false, force ? false,
source, source,
target target,
trace ? false
}: let }: let
target' = lib.mkTarget target; target' = lib.mkTarget target;
in in
@ -102,7 +140,7 @@ in
-A system \ -A system \
--keep-going \ --keep-going \
--no-out-link \ --no-out-link \
--show-trace \ ${lib.optionalString trace "--show-trace"} \
'<nixpkgs/nixos>' '<nixpkgs/nixos>'
''; '';
} }

View File

@ -1,7 +1,7 @@
with import ../../lib; with import ../../lib;
with shell; with shell;
{ coreutils, dash, findutils, git, jq, openssh, pass, rsync, writers }: { coreutils, dash, findutils, git, jq, openssh, pass, passage, rsync, writers }:
let let
check = { force, target }: let check = { force, target }: let
@ -45,18 +45,34 @@ let
''; '';
pop.file = target: source: let pop.file = target: source: let
configAttrs = ["useChecksum" "exclude" "filters" "deleteExcluded"]; config = rsyncDefaultConfig // derivedConfig // sourceConfig;
config = filterAttrs (name: _: elem name configAttrs) source; derivedConfig = {
useChecksum =
if isStorePath source.path
then true
else rsyncDefaultConfig.useChecksum;
};
sourceConfig =
filterAttrs (name: _: elem name (attrNames rsyncDefaultConfig)) source;
sourcePath =
if isStorePath source.path
then quote (toString source.path)
else quote source.path;
in in
rsync' target config (quote source.path); rsync' target config sourcePath;
pop.git = target: source: runShell target /* sh */ '' pop.git = target: source: runShell target /* sh */ ''
set -efu set -efu
# Remove target path if it doesn't look like a git worktree.
# This can happen e.g. when it had a different type earlier.
if ! test -e ${quote target.path}/.git; then
rm -fR ${quote target.path}
fi
if ! test -e ${quote target.path}; then if ! test -e ${quote target.path}; then
${if source.shallow then /* sh */ '' ${if source.shallow then /* sh */ ''
git init ${quote target.path} git init ${quote target.path}
'' else /* sh */ '' '' else /* sh */ ''
git clone --recurse-submodules ${quote source.url} ${quote target.path} git clone --recurse-submodules ${quote source.url} ${quote target.path}
''} ''}
fi fi
cd ${quote target.path} cd ${quote target.path}
@ -103,7 +119,15 @@ let
umask 0077 umask 0077
if test -e ${quote source.dir}/.git; then if test -e ${quote source.dir}/.git; then
local_pass_info=${quote source.name}\ $(${git}/bin/git -C ${quote source.dir} log -1 --format=%H ${quote source.name}) local_pass_info=${quote source.name}\ $(
${git}/bin/git -C ${quote source.dir} log -1 --format=%H ${quote source.name}
# we append a hash for every symlink, otherwise we would miss updates on
# files where the symlink points to
${findutils}/bin/find ${quote source.dir}/${quote source.name} -type l \
-exec ${coreutils}/bin/realpath {} + |
${coreutils}/bin/sort |
${findutils}/bin/xargs -r -n 1 ${git}/bin/git -C ${quote source.dir} log -1 --format=%H
)
remote_pass_info=$(${runShell target /* sh */ '' remote_pass_info=$(${runShell target /* sh */ ''
cat ${quote target.path}/.pass_info || : cat ${quote target.path}/.pass_info || :
''}) ''})
@ -119,28 +143,63 @@ let
rm -fR "$tmp_dir" rm -fR "$tmp_dir"
} }
${findutils}/bin/find ${quote passPrefix} -type f -follow | ${findutils}/bin/find ${quote passPrefix} -type f -follow ! -name .gpg-id |
while read -r gpg_path; do while read -r gpg_path; do
rel_name=''${gpg_path#${quote passPrefix}} rel_name=''${gpg_path#${quote passPrefix}}
rel_name=''${rel_name%.gpg} rel_name=''${rel_name%.gpg}
pass_date=$( pass_date=$(
${git}/bin/git -C ${quote source.dir} log -1 --format=%aI "$gpg_path" if test -e ${quote source.dir}/.git; then
${git}/bin/git -C ${quote source.dir} log -1 --format=%aI "$gpg_path"
fi
) )
pass_name=${quote source.name}/$rel_name pass_name=${quote source.name}/$rel_name
tmp_path=$tmp_dir/$rel_name tmp_path=$tmp_dir/$rel_name
${coreutils}/bin/mkdir -p "$(${coreutils}/bin/dirname "$tmp_path")" ${coreutils}/bin/mkdir -p "$(${coreutils}/bin/dirname "$tmp_path")"
PASSWORD_STORE_DIR=${quote source.dir} ${pass}/bin/pass show "$pass_name" > "$tmp_path" PASSWORD_STORE_DIR=${quote source.dir} ${pass}/bin/pass show "$pass_name" > "$tmp_path"
${coreutils}/bin/touch -d "$pass_date" "$tmp_path" if [ -n "$pass_date" ]; then
${coreutils}/bin/touch -d "$pass_date" "$tmp_path"
fi
done done
if test -n "''${local_pass_info-}"; then if test -n "''${local_pass_info-}"; then
echo "$local_pass_info" > "$tmp_dir"/.pass_info echo "$local_pass_info" > "$tmp_dir"/.pass_info
fi fi
${rsync' target {} /* sh */ "$tmp_dir"} ${rsync' target rsyncDefaultConfig /* sh */ "$tmp_dir"}
'';
pop.passage = target: source: /* sh */ ''
set -efu
export PASSAGE_AGE=${quote source.age}
export PASSAGE_DIR=${quote source.dir}
export PASSAGE_IDENTITIES_FILE=${quote source.identities_file}
umask 0077
tmp_dir=$(${coreutils}/bin/mktemp -dt populate-passage.XXXXXXXX)
trap cleanup EXIT
cleanup() {
rm -fR "$tmp_dir"
}
${findutils}/bin/find "$PASSAGE_DIR" -type f -name \*.age -follow |
while read -r age_path; do
rel_name=''${age_path#$PASSAGE_DIR}
rel_name=''${rel_name%.age}
tmp_path=$tmp_dir/$rel_name
${coreutils}/bin/mkdir -p "$(${coreutils}/bin/dirname "$tmp_path")"
${passage}/bin/passage show "$rel_name" > "$tmp_path"
${coreutils}/bin/touch -r "$age_path" "$tmp_path"
done
${rsync' target rsyncDefaultConfig /* sh */ "$tmp_dir"}
''; '';
pop.pipe = target: source: /* sh */ '' pop.pipe = target: source: /* sh */ ''
@ -168,17 +227,17 @@ let
source_path=$source_path/ source_path=$source_path/
fi fi
${rsync}/bin/rsync \ ${rsync}/bin/rsync \
${optionalString (config.useChecksum or false) /* sh */ "--checksum"} \ ${optionalString config.useChecksum /* sh */ "--checksum"} \
${optionalString target.sudo /* sh */ "--rsync-path=\"sudo rsync\""} \ ${optionalString target.sudo /* sh */ "--rsync-path=\"sudo rsync\""} \
${concatMapStringsSep " " ${concatMapStringsSep " "
(pattern: /* sh */ "--exclude ${quote pattern}") (pattern: /* sh */ "--exclude ${quote pattern}")
(config.exclude or [])} \ config.exclude} \
${concatMapStringsSep " " ${concatMapStringsSep " "
(filter: /* sh */ "--${filter.type} ${quote filter.pattern}") (filter: /* sh */ "--${filter.type} ${quote filter.pattern}")
(config.filters or [])} \ config.filters} \
-e ${quote (ssh' target)} \ -e ${quote (ssh' target)} \
-vFrlptD \ -vFrlptD \
${optionalString (config.deleteExcluded or true) /* sh */ "--delete-excluded"} \ ${optionalString config.deleteExcluded /* sh */ "--delete-excluded"} \
"$source_path" \ "$source_path" \
${quote ( ${quote (
optionalString (!isLocalTarget target) ( optionalString (!isLocalTarget target) (
@ -190,6 +249,13 @@ let
>&2 >&2
''; '';
rsyncDefaultConfig = {
useChecksum = false;
exclude = [];
filters = [];
deleteExcluded = true;
};
runShell = target: command: runShell = target: command:
if isLocalTarget target if isLocalTarget target
then command then command
@ -202,8 +268,7 @@ let
ssh' = target: concatMapStringsSep " " quote (flatten [ ssh' = target: concatMapStringsSep " " quote (flatten [
"${openssh}/bin/ssh" "${openssh}/bin/ssh"
(optionals (target.user != "") ["-l" target.user]) (mkUserPortSSHOpts target)
"-p" target.port
"-T" "-T"
target.extraOptions target.extraOptions
]); ]);